import clingo.ast

class ASTVisitor(object):

    def visit(self, x):
        if isinstance(x, clingo.ast.AST):
            attr = "visit_" + str(x.type)
            if hasattr(self, attr):
                return getattr(self, attr)(x)
            else:
                after = self.visit_children(x)
                return after
        elif isinstance(x, list):
            return [self.visit(y) for y in x]
        elif x is None:
            return x
        else:
            raise TypeError("unexpected type (%s)" % type(x))

    def visit_children(self, x):
        for key in x.child_keys:
            child_x = self.visit(getattr(x, key))
            x[key] = child_x
        return x
